using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;
using System.Text;
using System.IO;
using Microsoft.Win32;
using ClientControls;
using System.Text.RegularExpressions;

namespace SpringClient
{
	/// <summary>
	/// Summary description for Login.
	/// </summary>
	public class Login : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox Username;
		private System.Windows.Forms.TextBox Password;
		private System.Windows.Forms.Button Connect;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.CheckBox checkBoxRemember;
		private System.Windows.Forms.ErrorProvider errorProviderPassword;
		private System.Windows.Forms.ErrorProvider errorProviderUsername;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public string User
		{
			get
			{
				return Username.Text;
			}
		}

		public string Pass
		{
			get
			{
				return Password.Text;
			}
		}

		public Login()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// try and get registry information about remembering login
			try
			{
				RegistryKey rk = Registry.LocalMachine.OpenSubKey(@"Software\SY\SpringClient");
				if ( rk != null )
				{
					string name = (string)rk.GetValue("Username");
					string password = (string)rk.GetValue("Password");
					if ( name != null && password != null )
					{
						checkBoxRemember.Checked = true;
						Username.Text = name;
						Password.Text = password;
					}
					rk.Close();
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		} 

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Login));
			this.Username = new System.Windows.Forms.TextBox();
			this.Password = new System.Windows.Forms.TextBox();
			this.Connect = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.checkBoxRemember = new System.Windows.Forms.CheckBox();
			this.errorProviderPassword = new System.Windows.Forms.ErrorProvider();
			this.errorProviderUsername = new System.Windows.Forms.ErrorProvider();
			this.SuspendLayout();
			// 
			// Username
			// 
			this.Username.Location = new System.Drawing.Point(80, 24);
			this.Username.Name = "Username";
			this.Username.Size = new System.Drawing.Size(192, 20);
			this.Username.TabIndex = 0;
			this.Username.Text = "";
			// 
			// Password
			// 
			this.Password.Location = new System.Drawing.Point(80, 64);
			this.Password.Name = "Password";
			this.Password.PasswordChar = '*';
			this.Password.Size = new System.Drawing.Size(192, 20);
			this.Password.TabIndex = 1;
			this.Password.Text = "";
			// 
			// Connect
			// 
			this.Connect.Location = new System.Drawing.Point(160, 104);
			this.Connect.Name = "Connect";
			this.Connect.Size = new System.Drawing.Size(96, 24);
			this.Connect.TabIndex = 3;
			this.Connect.Text = "Connect";
			this.Connect.Click += new System.EventHandler(this.Connect_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 16);
			this.label1.TabIndex = 3;
			this.label1.Text = "Username";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(64, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = "Password";
			// 
			// checkBoxRemember
			// 
			this.checkBoxRemember.AutoCheck = false;
			this.checkBoxRemember.Location = new System.Drawing.Point(32, 104);
			this.checkBoxRemember.Name = "checkBoxRemember";
			this.checkBoxRemember.Size = new System.Drawing.Size(104, 32);
			this.checkBoxRemember.TabIndex = 2;
			this.checkBoxRemember.Text = "Remember login";
			this.checkBoxRemember.Click += new System.EventHandler(this.checkBoxRemember_Click);
			this.checkBoxRemember.CheckedChanged += new System.EventHandler(this.checkBoxRemember_CheckedChanged);
			// 
			// errorProviderPassword
			// 
			this.errorProviderPassword.ContainerControl = this;
			// 
			// errorProviderUsername
			// 
			this.errorProviderUsername.ContainerControl = this;
			// 
			// Login
			// 
			this.AcceptButton = this.Connect;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(288, 144);
			this.Controls.Add(this.checkBoxRemember);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.Connect);
			this.Controls.Add(this.Password);
			this.Controls.Add(this.Username);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Login";
			this.Text = "Login";
			this.Closed += new System.EventHandler(this.Login_Closed);
			this.ResumeLayout(false);

		}
		#endregion

		private void Connect_Click(object sender, System.EventArgs e)
		{
			if ( ValidateEntries() )
			{
				this.DialogResult = DialogResult.OK;
				Close();
			}
		}

		private bool ValidateEntries()
		{
			return ValidateLogin() && ValidatePassword();
		}

		private void Login_Closed(object sender, System.EventArgs e)
		{
		}

		private void checkBoxRemember_CheckedChanged(object sender, System.EventArgs e)
		{
		}

		private bool ValidatePassword()
		{
			if ( Password.Text.Length == 0 )
			{
				errorProviderPassword.SetError(Password, "Password cannot be blank");
				return false;
			}

			if ( Password.Text.Length > CONSTANTS.MAXPASSWD )
			{
				errorProviderPassword.SetError(Password, string.Format("Password cannot contain more than {0} characters", CONSTANTS.MAXPASSWD));
				return false;
			}

			if ( Regex.Match(Password.Text, "[a-zA-Z0-9]*", RegexOptions.None).Value != Password.Text )
			{
				errorProviderPassword.SetError(Password, "Password can only containg alphanumeric characters");
				return false;
			}
			errorProviderPassword.SetError(Password, "");
			return true;
		}

		private bool ValidateLogin()
		{
			if ( Username.Text.Length == 0 )
			{
				errorProviderUsername.SetError(Username, "Username cannot be blank");
				return false;
			}

			if ( Username.Text.Length > CONSTANTS.MAXNAME )
			{
				errorProviderUsername.SetError(Username, string.Format("Username cannot contain more than {0} characters", CONSTANTS.MAXPASSWD));
				return false;
			}

			if ( Regex.Match(Username.Text, "[a-zA-Z0-9_]*", RegexOptions.None).Value != Username.Text )
			{
				errorProviderUsername.SetError(Username, "Username can only contain alphanumeric characters");
				return false;
			}
			errorProviderUsername.SetError(Username, "");
			return true;
		}

		private void checkBoxRemember_Click(object sender, System.EventArgs e)
		{
			try
			{
				CheckBox cb = (CheckBox)sender;
				if ( !cb.Checked )
				{
					if ( !ValidateEntries() )
					{
						return;
					}
					// then save info
					RegistryKey rk = Registry.LocalMachine.OpenSubKey(@"Software\SY\SpringClient", true);
					if ( rk == null )
					{
						rk = Registry.LocalMachine.CreateSubKey(@"Software\SY\SpringClient");
						if ( rk == null )
						{
							MessageBox.Show("Failed to create registry entry");
							return;
						}
					}
					rk.SetValue("Username", Username.Text);
					rk.SetValue("Password", Password.Text);
					//		cb.Checked = true;
					cb.CheckState = CheckState.Checked;
				}
				else
				{
					RegistryKey rk = Registry.LocalMachine.OpenSubKey(@"Software\SY\SpringClient", true);
					if ( rk != null )
					{
						rk.DeleteValue("Username", false);
						rk.DeleteValue("Password", false);
					}
					cb.CheckState = CheckState.Unchecked;
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}
	}
}