#pragma once
#include "object.h"
#include <set>
#include <list>
#include <vector>
#include <string>

class CUnit;

struct TrackPart {
	float3 pos1;
	float3 pos2;
	float texPos;
	bool connected;
	int creationTime;
};

struct UnitTrackStruct{
	CUnit* owner;
	int lifeTime;
	int trackAlpha;
	float alphaFalloff;
	std::list<TrackPart> parts;
};

class CGroundDecalHandler :
	public CObject
{
public:
	CGroundDecalHandler(void);
	virtual ~CGroundDecalHandler(void);
	void Draw(void);
	void Update(void);
	void UnitMoved(CUnit* unit);
	void RemoveUnit(CUnit* unit);
	int GetTrackType(std::string name);

	int decalLevel;

	struct TrackType {
		std::string name;
		std::set<UnitTrackStruct*> tracks;
		unsigned int texture;
	};
	std::vector<TrackType*> trackTypes;
	unsigned int LoadTexture(std::string name);
};

extern CGroundDecalHandler* groundDecals;
